﻿# -*- coding: utf_8 -*-

version = '0.0.2'

from clapi import *
from clconst import *
from clmode import BaseMode
from clbmitem import Item

import clmode
import clwindow
import clKanji
import clcore
from clbmcache import Cache
from clbmxml import Xml
import clbmwwwc
import clbmopml
from clbmdelicious import Delicious

import time
import os,os.path
import win32gui
import win32api
import win32con
import win32process
import clmode

def activateBrowser(path):
    path = os.path.normpath(path)
    
    def cb(hwnd, arg):
        if not win32gui.IsWindowVisible(hwnd):return
        exstyle = win32api.GetWindowLong( hwnd, win32con.GWL_EXSTYLE )
        if exstyle & win32con.WS_EX_TOOLWINDOW:return
        if not win32gui.GetWindowText(hwnd):return
        
        (threadid, pid) = win32process.GetWindowThreadProcessId(hwnd)
        hprocess = win32api.OpenProcess(win32con.PROCESS_ALL_ACCESS, False, pid)
        filepath = os.path.normpath(win32process.GetModuleFileNameEx(hprocess, 0))
        win32api.CloseHandle(hprocess)
        filepath = unicode(os.path.normpath(filepath))
        arg.append( (filepath,hwnd ) )
        
    lst = []
    clcore.EnumWindows(cb,lst)
    for filepath,hwnd in lst:
        if path.lower() == filepath.lower():
            SetForegroundWindow(hwnd)
            break
    
class ItemBrowser:
    items = []
    def __init__(self, name, file):
        self.name = name
        self.file = file
        self.__class__.items.append(self)
        
    def __call__(self, item_url):
        if ShellExecute(open, self.file, item_url(), os.path.dirname(self.file), 0) == 0:
            activateBrowser(self.file)
        else:
            raise CommandFailedException
        
    def reset():
        ItemBrowser.items = []
    reset = staticmethod(reset)

class BookmarkMode( BaseMode ):
    """Bookmark Mode"""
    def __init__(self):
        BaseMode.__init__(self)
        self.candlist = []
        self.tag_his = []
        self.tag_selected = set() #選択中のタグ
        self.text = '' # アクティブ化した時に前回の入力を復元用
        self.sel = ()
        self.str_status = 'bm'
        self.idx = 2
        
        self.url = '' #ブラウザ選択用
        
        self.original_pos = GetOption( OPTION_ORIGINAL_POSITION )
        self.original_max = GetOption( OPTION_LIST_MAX )
        self.original_abbrev = GetOption( OPTION_ABBREV_AUTO )
        if not GetOption(OPTION_BM_POS):
            SetOption(OPTION_BM_POS, self.original_pos)
        if not GetOption(OPTION_BM_MAX):
            SetOption(OPTION_BM_MAX, self.original_max)
        if GetOption(OPTION_BM_VIEW_MAX) == None:
            SetOption(OPTION_BM_VIEW_MAX, GetOption(OPTION_BM_MAX) * 2)
        
        ItemBrowser.reset()
        browser = GetOption(OPTION_BM_BROWSER)
        if browser:
            for name in browser.keys():
                file = browser[name]
                ItemBrowser(name, file)
                
        self.SetKeyDownHandler( ord('S'), MODKEY_CTRL, self.sortToggle )
        #self.SetKeyDownHandler( VK_F5, 0, self.checkWwwc )
        self.SetKeyDownHandler( ord('I'), MODKEY_CTRL, self.displayInfo )
        self.SetKeyDownHandler( ord('D'), MODKEY_CTRL, self.deleteItem )
        self.SetKeyDownHandler( ord('O'), MODKEY_CTRL, self.Shortcut_ShowOutput )
        self.SetKeyDownHandler( VK_LEFT, 0, self.popTagStack )
        self.SetKeyDownHandler( VK_RIGHT, 0, self.pushTagStack )
        self.SetKeyDownHandler( VK_SPACE, 0, self.Shortcut_down )
        self.SetKeyDownHandler( VK_DOWN, 0, self.Shortcut_down )
        self.SetKeyDownHandler( VK_UP, 0, self.Shortcut_up )
        self.SetKeyDownHandler( VK_RETURN, MODKEY_CTRL, self.OnExecuteEx )
        
    def OnPush(self):
        try:
            Cache.load()
        except IOError,e:
            print 'can not load cache file when OnPush.(BookmarkMode)\n%s' % e
        Item.setCmdFuncMap('about',self.show_version)
        if not Item.find('about','id')[0]:
            Item.setItemCmd('about',u'about BookmarkMode',[u'about'])
            
        Xml.start()
        Delicious.start()
        clbmwwwc.start()
        clbmopml.start()
        
    def OnGetControl(self):
        pos = GetOption(OPTION_BM_POS)
        SetPos(pos[0], pos[1])
        SetImeStatus(False)
        SetStatusIndicator(self.str_status)
        SetOption(OPTION_ABBREV_AUTO, False)
        SetOption(OPTION_LIST_MAX, GetOption(OPTION_BM_MAX))
        self.popupBM()
        
    def OnLoseControl(self):
        x,y=self.original_pos
        SetPos(x,y)
        SetStatusIndicator('')
        SetOption(OPTION_ABBREV_AUTO, self.original_abbrev)
        SetOption(OPTION_LIST_MAX,self.original_max)
        try:
            Cache.save()
        except IOError,e:
            print 'can not save cache file when OnPop.(BookmarkMode)\n%s' % e
        SetValue('')
        PopList([])
        
    def OnActivate( self, event):
        if event.active:
            if self.text or self.sel:
                SetValue(self.text)
                SetSelection(self.sel[0],self.sel[1])
            self.popupBM()
        else:
            self.text = GetValue()
            self.sel = GetSelection()
            original_pos = GetOption( OPTION_ORIGINAL_POSITION )
            SetPos( *original_pos )
            
            submode = GetOption(OPTION_EX_SUBMODE)
            
            if not (submode == ''):
                str  = 'import ' + submode + '\n'
                str += submode + '.OnSubmode()'
                exec str in globals(), locals()
            else:
                SetImeStatus(False)
            PopList([])
            
    def OnSelChange( self, event ):
         print 'in OnSelChange',GetListSelection()
         SetListSelection(2)
         self.idx=2
        
    def ListupAbbrevCandidate(self, value_str, value_sel):
        urls, tags, cmds = Item.abbrev(self.tag_selected, value_str)
        max_url, max_tag ,max_cmd = GetOption(OPTION_BM_VIEW_MAX)
        if max_url:
            urls = urls[:max_url]
        if max_tag:
            tags = tags[:max_tag]
        if max_cmd:
            cmds = cmds[:max_cmd]
        self.candlist = urls + tags + cmds
        
        res = [unicode(' + '.join(self.tag_selected)),'--------------------']
        res.extend([cand.getStr(self.tag_selected) for cand in urls + tags + cmds])
        
        if len(res) > 2:
            SetStatusIndicator(self.str_status)
        else :
            SetStatusIndicator('??')
        
        return res, 0
    
    def OnAbbrev(self, event):
        pass
    
    def OnKeyDown( self, event ):
        BaseMode.OnKeyDown( self, event )
        if event.vk == VK_ESCAPE:
            self.ModeQuit()
            event.Skip()
            
        if event.vk == VK_BACK or event.vk == VK_DELETE:
            pos = GetSelection()
            str = GetValue()
            if str=='':
                if len(self.tag_selected)==0:
                    return
                elif len(self.tag_selected)>0:
                    self.popTagStack()
                    
            if pos[0] > 0 and pos[0] == pos[1]:
                if event.vk == VK_DELETE:
                    if pos[0] < len(str):
                        str = str[0:pos[0]] + str[pos[1]+1:]
                if event.vk == VK_BACK:
                    if pos[0] > 0:
                        str = str[0:pos[0]-1] + str[pos[1]:]
                        pos = (pos[0] -1, pos[1] -1)
            else:
                str = str[0:pos[0]] + str[pos[1]:]
                
            SetValue(str)
            event.str = str
            SetSelection(pos[0], pos[0])
            self.popupBM()
            event.Skip()
            
    def isAbbrevChar(self, vk, mod):
        return chr(vk).isalnum() or chr(vk) in "',.;-/\\"
    
    def isSettleChar(self, vk, mod):
        return chr(vk) in "./\\;"
    
    def OnExecute(self, event):
        u"""関連付けされたプログラムでURLを開く"""
        if self.idx < 2:
            return
        
        item = self.candlist[self.idx - 2]
        if item.__class__.__name__ == 'ItemTag':
            item()
            if len(self.tag_selected)>0 and item._text in self.tag_selected:
                self.tag_selected.remove(item.text)
            else:
                self.tag_selected.add(item.text)
            SetValue('')
            self.idx = 2
            self.popupBM()
            raise ShowInfoException
            
        elif item.__class__.__name__ == 'ItemUrl':
            if ShellExecute('', item(), '', '', 0) == 0:
                pass
            else:
                raise CommandFailedException, 'shell execute error.'
            SetValue('')
            
        
        elif item.__class__.__name__ == 'ItemBrowser':
            try:
                item(self.url)
            except CommandFailedException:
                raise CommandFailedException, 'shell execute error.'
            self.url = ''
            self.text = ''
            PopList([])
            
        elif item.__class__.__name__ == 'ItemCmd':
            item()
            SetValue('')
            self.popupBM()
            raise ShowInfoException
        else:
            pass
        
    def OnExecuteEx(self):
        u"""ブラウザを選択してURLを開く"""
        if self.idx < 2:
            return
        
        item = self.candlist[self.idx - 2]
        if item.__class__.__name__ == 'ItemUrl' and GetOption(OPTION_BM_BROWSER):
                self.url = item
                plist = [unicode(' + '.join(self.tag_selected)),'--------------------']
                plist.extend([b.name for b in ItemBrowser.items])
                PopList(plist)
                self.candlist = [b for b in ItemBrowser.items]
        else:
            self.OnExecute(None)
        
    def displayInfo(self):
        u"""選択アイテムの情報を表示"""
        if self.idx<2:pass
        MessageBox(self.candlist[self.idx-2].showInfo(),'bookmark infomation' , MB_OK)
        
    def deleteItem(self):
        u"""選択アイテムの削除"""
        if self.idx<2:pass
        item = self.candlist[self.idx - 2]
        msgstr = u'以下を削除します。よろしいですか？\n\n' + item.showInfo()
        if MessageBox(msgstr, 'BookMarkMode', MB_YESNO) == IDYES:
            item.remove()
            Item.change_flag = 1
            self.popupBM()
        else:
            pass
        
    def popupBM(self):
        clwindow.edit.Abbrev(select = 2)
        clwindow.edit.last_action = 1
        if self.idx>1:
            SetListSelection(self.idx)
        else:
            SetListSelection(2)
        
    def ModeQuit(self):
        SetValue('')
        PopList([])
        PopMode()
        
    def popTagStack(self):
        u"""タグ選択アンドゥ"""
        if len(self.tag_selected)>0:
            self.tag_his.append( self.tag_selected.pop() )
            self.popupBM()
            
    def pushTagStack(self):
        u"""タグ選択リドゥ"""
        if len(self.tag_his)>0:
            self.tag_selected.add( self.tag_his.pop() )
            self.popupBM()
        
    def sortToggle(self):
        u"""更新した順にソート,開いた頻度順にソート トグル"""
        if GetOption(OPTION_BM_SORT_BY_UPDATE):
            SetOption(OPTION_BM_SORT_BY_UPDATE,0)
        else:
            SetOption(OPTION_BM_SORT_BY_UPDATE,1)
        self.popupBM()
        
    def Shortcut_down(self):
        id = GetListSelection()
        max = GetListCount() - 1
        if id < 2 or id == max:
            SetListSelection(0)
            SetListSelection(2)
            self.idx=2
        elif 1 < id < max:
            SetListSelection(id+1)
            self.idx = id + 1
            
    def Shortcut_up(self):
        id = GetListSelection()
        max = GetListCount() - 1
        if id < 3:
            SetListSelection(max)
            self.idx=max
        elif 2 < id < max + 1:
            SetListSelection(id-1)
            self.idx = id - 1
        
    def Shortcut_ShowOutput(self):
        clcore.Output_Show( not clcore.Output_IsShown() )
        
    def show_version(self):
        msg = u'BookmarkMode\nversion %s \nmade by シロ' % version
        MessageBox(msg,'BookmarkMode' , MB_OK)
