﻿# -*- coding: utf_8 -*-

try:
    import delicious
except ImportError:
    print 'delicious.pyがないです'
from clbmitem import Item

from clapi import *
from clconst import *

class Delicious:
    convert_tag_map = {}
    
    def importData():
        deluser = GetOption(OPTION_BM_DEL_USER)
        delpass = GetOption(OPTION_BM_DEL_PASS)
        if not deluser or not delpass:
            print 'del.icio.usの設定をしてないです'
            return
        deltags = set([deltag['tag'] for deltag in delicious.get_tags(deluser,delpass)])
        deldata = delicious.get_all(deluser,delpass)
        Delicious.setTags(deltags)
        Delicious.setUrls(deldata)
    importData = staticmethod(importData)
    
    
    def setTags(deltags):
        members = Item.getAllMember()
        new_tags = deltags - members
        # entry new tag item
        for tag in new_tags:
            Delicious.convert_tag_map[tag] = tag
            Item.setItemTag(tag,[tag],[])
            
        # member -> tagobj._text
        for new_tag in deltags & members:
            Delicious.convert_tag_map[new_tag] = Item.find(new_tag,'member')[0]._text
    setTags = staticmethod(setTags)
    
    
    def setUrls(deldata):
        # entry new url item
        for item in deldata:
            text = item['description']
            kanas = []
            url = item['url']
            open = ''
            description = item['extended']
            tags = []
            for tag in item['tags'].split(' '):
                tags.append(Delicious.convert_tag_map[tag])
            Item.setItemUrl(text, kanas, url, open, description, tags)
    setUrls = staticmethod(setUrls)
    
    def start():
        Item.setCmdFuncMap('importdelicious',Delicious.importData)
        if not Item.find('importdlicious','id')[0]:
            Item.setItemCmd('importdelicious',u'Import del.icio.us',[u'importdelicious'])
    start = staticmethod(start)
    