﻿# -*- coding: utf_8 -*-

import time

from clconst import *
from clapi import *
from clbmitem_base import BaseItem as Base

# ------------------------------------------------------------------ 
# Item command class                                                |
# ------------------------------------------------------------------ 
""" id

about
savexml
loadxml
loadopml
loadwwwc
loadie
"""

class ItemCmd(Base):
    u'''this class deal with command item.'''
    _items = []
    func_map = {}
    
    def __init__(self, id, text, kanas=[u''], frequency=0, visit=0):
        self.id = id
        self.set(_text=text, _kanas=kanas, _visit=visit, _frequency=frequency)
        
    def __call__(self):
        Base.__call__(self)
        self.__class__.func_map[self.id]()
        
    def getStr(self, arg=None):
        return u'>> '+self.text
    
    def showInfo(self):
        res = []
        res.append(self.baseInfo())
        res.append('id : ' + self.id)
        return '\n'.join(res)
    
    def checkDuplication(self):
        for old in ItemCmd._items:
            if old.id == self.id and old.text.lower() == self.text.lower() and old.kanas == self.kanas:
                return 1
            elif old.id == self.id:
                return old
            else:
                pass
