﻿# -*- coding: utf_8 -*-

from clconst import *
from clapi import *
from clbmitem_base import BaseItem as Base

# ------------------------------------------------------------------ 
# Item tag class                                                    |
# ------------------------------------------------------------------ 
"""
text      str   タグの名前 (view)
kanas     [str] ローマ字表記された名前 (search)
frequency int   開いた回数 (sort)
visit     int   最後に開いた時間 (sort)

member    [str] メンバに含まれるタグを持つサイトをtextというタグで一括で表記する。(sort,search)

正しい引数を与えれば値を設定。
"""

class ItemTag(Base):
    u'''this class deal with tag item.'''
    _items = []
    
    def __init__(self, text=u'', kanas=[u''], member=[u''], visit=0, frequency=0):
        self.member = member
        self.set(_text=text, _kanas=kanas, _visit=visit, _frequency=frequency)
        
    def showInfo(self):
        res = []
        res.append(self.baseInfo())
        res.append('member : ' + '|'.join(self.member))
        return '\n'.join(res)
    
    def getStr(self, arg=None):
        if arg == None:
            return '  %s' % self.text
        else:
            for sel in arg:
                if sel == self.text:
                    return '+ %s' % self.text
            else:
                return '  %s' % self.text
    
    def checkDuplication(self):
        for old in self.__class__._items:
            if old.text.lower() == self.text.lower() and old.kanas == self.kanas and old.member == self.member:
                return 1
            elif old.text.lower() == self.text.lower():
                return old
            else:
                pass
    
    def makeOverwriteMsg(self, old):
        msg,msgtitle = Base.makeOverwriteMsg(self, old)
        
        _omember = '|'.join(old.kanas)
        _nmember = '|'.join(self.kanas)
        msg.extend(['member : ' + _omember + '\n','member : ' + _nmember + '\n\n'])
        if not _nmember.lower() == _omember.lower():
            msg[-1], msg[-2] = '* '+msg[-1], '* '+msg[-2]
            
        return msg,msgtitle
    
