﻿# -*- coding: utf_8 -*-

from xml.dom.minidom import parse
from clbmitem import Item
import os.path
from clapi import GetOption
from clconst import *

def parseOpml(node):
    while node:
        if node.nodeName == 'head':
            node = node.nextSibling
        if node.hasChildNodes:
            parseOpml(node.firstChild)
        if node.nodeType == node.ELEMENT_NODE and node.nodeName == 'outline':
            if node.getAttribute('type')=='rss':
                tags = setTags(node)
                setUrls(node,tags)
                p_node=node.parentNode
                if node == p_node.lastChild:
                    node = p_node
        node = node.nextSibling
        
def loadOpml():
    path = GetOption(OPTION_BM_OPML)
    x = os.path.split(path)
    name,ext = os.path.splitext(path)
    if not os.path.exists(path) or not ext == '.opml':
        print '%s is not opml file.' % exe_path
        return
    
    try:
        dom = parse(path)
    except IOError:
        print 'ERROR : no bookmark xml file.'
        return
    
    node = dom.documentElement.firstChild
    parseOpml(node)
    
def setUrls(node,tags):
    text = node.getAttribute('text')
    if not text:
        text = node.getAttribute('title') # title要素だけ付けてるOPMLのために一応。
    kanas = []
    url = node.getAttribute('htmlUrl')
    open = u''
    description = node.getAttribute('description')
    up = 0
    rss = node.getAttribute('xmlUrl')
    Item.setItemUrl(text, kanas, url, open, description, tags, up, rss)

def setTags(node):
    tags = set()
    temp_node = node.parentNode
    while temp_node:
        if temp_node.parentNode.nodeName == 'body':
            break
        tags.add(temp_node.getAttribute('text').lower())
        temp_node = temp_node.parentNode
    
    members = Item.getAllMember()
    new_tags = tags - members
    
    for tag in new_tags:
        Item.setItemTag(tag,[tag],[])
    for member in tags & members:
        tags = Item.find(member,'member')[0]
        if not tags:
            continue
        new_tags.add(tags.text)
    
    return list(new_tags)

def start():
    Item.setCmdFuncMap('importopml',loadOpml)
    if not Item.find('importopml','id')[0] and GetOption(OPTION_BM_OPML):
        Item.setItemCmd('importopml',u'Import OPML file',[u'importopmlfile'])
    
