﻿# -*- coding: utf_8 -*-

import os.path
from clconst import *
from clapi import *
from clbmitem import Item,lower
from time import time
from clsubmode_clock import subMode_Clock

def glob3(path):
    for root, dirs, files in os.walk( unicode(os.path.dirname(path)) ):
        for name in files:
            p = os.path.join(root, name)
            name,ext = os.path.splitext(p)
            yield os.path.normpath(p),ext
        for name in dirs:
            p = os.path.join(root, name)
            name,ext = os.path.splitext(p)
            yield os.path.normpath(p),ext
            
def importData():# arg_path is path of wwwc.exe
    nsc = 0
    exe_path = GetOption(OPTION_BM_WWWC)
    x = os.path.split(exe_path)
    if not os.path.exists(exe_path) or not x[1] == 'wwwc.exe':
        print '%s is not wwwc.exe' % exe_path
        return
    
    if os.path.exists(os.path.normpath(os.path.join(x[0], 'script', 'nsc.dll'))):
        nsc = 1
    
    for path,ext in glob3(exe_path):
        if not ext == '.dat':
            continue
        
        try:
            f = [unicode(line,'mbcs')for line in open(path,'r+').readlines()]
        except IOError,e:
            print e
            return
        
        for elements in f[:-1]:
            element = elements.split('\t')
            if nsc:
                url = element[8]
            else:
                url = element[1]
                
            if not url:
                continue
            
            item = Item.find(url,'url')[0]
            if not item:
                # add tags
                tags = os.path.dirname(path[len(os.path.dirname(exe_path)):]).split('\\')
                if '' in tags:
                    tags.remove('')
                tags.pop(0) # delete user name
                tags = setTags(tags)
                # add url
                setUrls(element, tags, nsc)
                
            else:
                # update
                uptime = element[3]
                if not uptime:
                    continue
                uptime = long(uptime[0:4] + uptime[5:7] + uptime[8:10] + uptime[11:13] + uptime[14:16])
                if uptime > item.up:
                    item.up = uptime
                    subMode_Clock.update += 1
                
                if nsc:
                    open_url = unicode(element[9])
                    if open_url:
                        item.open = open_url
                    else:
                        item.open = u''
                
                Item.change_flag = 1
                if IsActive():
                    subMode_Clock.update = 0

def setTags(tags):
    tags = set(lower(tags))
    members = Item.getAllMember()
    new_tags = tags - members
    
    for tag in new_tags:
        Item.setItemTag(tag,[tag],[])
    for member in tags & members:
        tags = Item.find(member,'member')
        if not tags[0]:
            continue
        new_tags.add(tags[0].text)
    return list(new_tags)

def setUrls(element, tags, nsc):
    text = element[0]
    up = element[3]
    if up:
        up = long(up[0:4] + up[5:7] + up[8:10] + up[11:13] + up[14:16])
    description = element[11]
    
    url = u''
    rss = u''
    open = u''
    kanas = []
    if nsc:
        if unicode(element[14]) == u'rss':
            rss = element[1]
        url = element[8]
        open = unicode(element[9])
    else:
        open = u''
    Item.setItemUrl(text, kanas, url, open, description, tags, up, rss)
    
def start():
    Item.setCmdFuncMap('importwwwc',importData)
    
    if not Item.find('importwwwc','id')[0] and GetOption(OPTION_BM_WWWC):
        Item.setItemCmd('importwwwc',u'Import WWWC data',[u'importwwwcdata'])
    """
nsc
0 サイト名
1 チェックURL
2 ?
3 更新時間
4 未読=1 既読=0
5 巡回した時間
6 md5(多分)
7 グリニッジ
8 登録したURL
9 開くURL
10 ?
11 コメント
12 ?
13 変更点等
14 取得方法


old
0 サイト名
1 URL
2
3 更新時間
4 未読=1 既読=0
5 2005/05/30 21:27
6
7 2005/04/26 18:55
8
9  0;;0;;0;;0;;0;;;;;;;;0
10 0;;0;;;;;;0;;;;
11 コメント
12 0
13 
14 Sun, 29 May 2005 13:49:40 GMT	
"""