﻿# -*- coding: utf_8 -*-

from xml.dom.minidom import parse

from clconst import *
from clapi import *
from clbmitem import Item,lower
import codecs

class Xml:
    path = GetOption(OPTION_BM_XML)
    
    def factory(key):
        if key == 'tag':
            return Xml.setTags
        elif key == 'url':
            return Xml.setUrls
        elif key == 'cmd':
            return Xml.setCmds
    factory = staticmethod(factory)
    
    def load():
        try:
            f = open(Xml.path)
        except IOError,e:
            print '%s \n at load bookmark xml file.' % e
            return
        
        doc = parse(f)
        if not doc.documentElement.tagName == 'BookMarkModeRoot':
            print "ERROR : %s is not bookmarkMode xml file." % path
            return
        
        node = doc.documentElement.firstChild
        while node:
            if not node.nodeType == node.ELEMENT_NODE:
                node = node.nextSibling
                continue
            try:
                Xml.factory(node.nodeName)(node)
            except CommandXmlParseException:
                print "%s is unknown type." % node.nodeName
            
            node = node.nextSibling
    load = staticmethod(load)
    
    def save():
        
        def convXML(text):
            return text.replace(u"&", u"&amp;")\
                   .replace(u"<", u"&lt;")\
                   .replace(u">", u"&gt;")\
                   .replace(u"'", u"&apos;")\
                   .replace(u'"', u"&quot;")
        
        buf = []
        buf.append(chr(60)+'?xml version="1.0" encoding="utf-8"?'+chr(62)+'\n'+chr(60)+'BookMarkModeRoot'+chr(62)+'\n\n')
        for item in Item.getAll():
            text = convXML(item.text)
            kanas = [convXML(kana) for kana in item.kanas]
            
            if item.__class__.__name__ == 'ItemTag':
                member = [convXML(member) for member in item.member]
                
                buf.append('        ' + chr(60) + 'tag    text="' + text + '"\n')
                buf.append('                kana="' + '|'.join(kanas) + '"\n')
                buf.append('                member="' + '|'.join(member) + '"')
            elif item.__class__.__name__ == 'ItemUrl':
                tags = [convXML(tag) for tag in item.tags]
                description = convXML(item.description)
                url = convXML(item.url)
                
                buf.append('        ' + chr(60) + 'url    text="' + text + '"\n')
                buf.append('                kana="' + '|'.join(kanas) + '"\n')
                buf.append('                tags="' + '|'.join(tags) + '"\n')
                buf.append('                description="' + description + '"\n')
                buf.append('                url="' + url + '"')
            elif item.__class__.__name__ == 'ItemCmd':
                buf.append('        ' + chr(60) + 'cmd    text="' + text + '"\n')
                buf.append('                kana="' + '|'.join(kanas) + '"\n')
                buf.append('                id="' + item.id + '"')
                
            buf.append('/'+ chr(62) +'\n\n')
        buf.append(chr(60)+'/BookMarkModeRoot'+chr(62)+'\n')
        utf8_codec = codecs.lookup('UTF-8')
        try:
            f = utf8_codec[3](file(Xml.path, 'wb+'))
        except IOError,e:
            print '%s \n at save bookmark xml file.' % e
            return
        f.write(''.join(buf))
        return
    save = staticmethod(save)
    
    def setTags(node):
        text = node.getAttribute('text')
        kanas = [kana for kana in node.getAttribute('kana').split('|')]
        member = [member for member in node.getAttribute('member').split('|')]
        Item.setItemTag(text, member, kanas)
    setTags = staticmethod(setTags)
    
    def setUrls(node):
        text = node.getAttribute('text')
        kanas = [kana for kana in node.getAttribute('kana').split('|')]
        url = node.getAttribute('url')
        tags = [tag for tag in node.getAttribute('tags').split('|')]
        
        tags = set(lower(tags))
        members = Item.getAllMember()
        new_tags = tags - members
        for tag in new_tags:
            Item.setItemTag(tag,[],[])
        for member in tags & members:
            tag = Item.find(member,'member')[0]
            if not tag:
                continue
            new_tags.add(tag.text)
        if new_tags:
            tags = list(new_tags)
        else:
            tags = [u'']
        
        description = node.getAttribute('description')
        rss = u''
        open = u''
        Item.setItemUrl(text, kanas, url, open, description, tags)
    setUrls = staticmethod(setUrls)
    
    def setCmds(node):
        text = node.getAttribute('text')
        kanas = [kana for kana in node.getAttribute('kana').split('|')]
        id = node.getAttribute('id')
        return Item.setItemCmd(id, text, kanas)
    setCmds = staticmethod(setCmds)
    
    def start():
        Item.setCmdFuncMap('importxml',Xml.load)
        Item.setCmdFuncMap('exportxml',Xml.save)
        if not Item.find('importxml','id')[0]:
            Item.setItemCmd('importxml',u'Import XML file',[u'importxml'])
        if not Item.find('savexml','id')[0]:
            Item.setItemCmd('exportxml',u'Export XML file',[u'exportxml'])
        
    start = staticmethod(start)
    
    